<?php
include_once('../../core/db/mysql.php');
session_start();
class API
{
	public $name_db;
	public function __construct($name_db) 
    { 
		$this->name_db = $name_db; 
	} 
	
	public function call($data)
	{
		$result = [];
		$_data = json_decode($data,true);

		if(isset($this->name_db))
		{
			$sql = new Mysql($this->name_db);
			
			$result["data"]= $_data;
			
			$action = $_data['action'];
			
			switch($action)
			{
				// BASIC DB CALLS //
				case "update": $result["response"] = $sql->insertUpdate($_data); break;
				case "delete": $result["response"] =$sql->delete($_data); break;
				case "list": $result["response"] =$sql->getRows($_data); break;

				// AUTH CALLS //
				case "select_auth_from_auth_hash": $result["response"] = $sql->getAuthFromAuthHash($_data); break;
				case "delete_auth": $result["response"] = $sql->deleteAuth($_data); break;

				// CLIENT CALLS //
				case "select_client_id": $result["response"] = $sql->getClientIdFromUserId($_data); break;
				case "get_client_id_from_order_id": $result["response"] = $sql->getClientIdFromOrderId($_data); break;
				case "select_client_from_client_id": $result["response"] = $sql->getClientFromClientId($_data); break;
				case "select_client_from_client_email": $result["response"] = $sql->getClientFromClientEmail($_data); break;
				case "edit_address": $result["response"] = $sql->editClientAddress($_data); break;
				
				// ORDER CALLS //
				case "get_order_from_order_number": $result["response"] = $sql->getOrderFromOrderNumber($_data); break;
				case "edit_order": $result["response"] = $sql->editOrder($_data); break;
				
				// USER LOGIN CALLS //
				case "select_user": $result["response"] = $sql->getUser($_data); break;
				case "get_user_from_user_id": $result["response"] = $sql->getUserFromUserId($_data); break;
				case "get_user_id_from_client_id": $result["response"] = $sql->getUserIdFromClientId($_data); break;
				case "get_orders": $result["response"] = $sql->getOrders($_data); break;
				


				default :$result["response"] = []; break;
			}
		}
		return json_encode($result);
	}
}

$request_json = $_REQUEST['request'];

if($request_json)
{
	$request = json_decode($request_json,true);
	
	$db=$_SESSION["db"];

	$api = new API($db);

	echo $api->call($request_json);
}




