<?php

include "../../core/util/util.php";

class MySql
{
    var $servername = "localhost";
    var $username = "root";
    var $password = "hcet";
    var $name_db = "core_db";

    public function __construct($name_db) 
    { 
      	$this->name_db = $name_db;
      	
	if(getenv("TANIA_USER")) $this->username = getenv("TANIA_USER");
	if(getenv("TANIA_PASS")) $this->password = getenv("TANIA_PASS");
	if(getenv("TANIA_HOST")) $this->servername = getenv("TANIA_HOST");
	if(getenv("TANIA_NAME")) $this->name_db = getenv("TANIA_NAME");
    } 

    function getConn($name_db=null)
    {
        $result = [];
        if(!isset($name_db)) $conn = new mysqli($this->servername, $this->username, $this->password);
        else  $conn = new mysqli($this->servername, $this->username, $this->password,$name_db);
        
        if(isset($conn))
        {
            if ($conn->connect_error) $result['error']= "DB Connect error: " . $conn->connect_error ;
            else $result["conn"] = $conn;
        }
        else 
        { 
            $result['error']= "Error connection failed";
        }
        return $result;
    }

    function buildDb()
    {
        $conn_request = $this->getConn();

        $conn = $conn_request["conn"];

        $response = [];
        $response['name'] = $this->name_db;
        if(!isset($conn_request['error']))
        {
            $sql = "CREATE DATABASE IF NOT EXISTS $this->name_db ";
            if ($conn->query($sql) === TRUE) 
            {
                $response['message'] = "database created successfully";
            } 
            else 
            {
                $response['error']= "Error: " . $conn->error;
            }
        
            $conn->close();
        }
        else  $response['error'] = $conn_request['error'];
        return $response;
    }
    
    function buildTable($name_table, $fields)
    {
        $conn_request = $this->getConn($this->name_db);
        $conn = $conn_request["conn"];

        $response = [];
        $response['name'] = $name_table;

        if(!isset($conn_request['error']))
        {
            if(is_array($fields))
            {
                $Id = "id INT(64) UNSIGNED AUTO_INCREMENT PRIMARY KEY";

                $sql = "CREATE TABLE IF NOT EXISTS $name_table ($Id,".implode(',',$fields).") ENGINE=INNODB";

				try
				{
					if ($conn->query($sql) === TRUE) 
					{
						$response['message'] = "table created successfully";
					} 
					else 
					{
						$response['error']= "creating table ERROR $sql";
					}
				} catch (\Throwable $th) 
				{
					$response['error']= "SQL FAILED $sql" ;
				}
               
            
                $conn->close();
            }
        }
        else  $response['error'] = $conn_request['error'];
        return $response;
    }
	// BASIC CALLS //
		function insertUpdate($data)
		{
			$conn_request = $this->getConn($this->name_db);
			$conn = $conn_request["conn"];
			$name_table = $data['table'];
			$_data = $data['data'];

			$response = [];
			$response['data'] = $_data;
			if(isset($conn_request['error'])) $response['error'] = $conn_request['error'];
			else
			{
				if(is_array($_data))
				{
					$sql = "";
					$update = false;
					if(key_exists("id",$_data))
					{
						$update = true;
						$sql = "UPDATE $name_table SET ";
						$count = 0;
						foreach ($_data as $key => $value) 
						{
							if($key!="id")
							{
								$field = " ".$key." = '".$value."'";
								if($count==0)
								{
									$sql.=$field;
									$count = 1;
								}
								else $sql.=", ".$field;
							}
						}
						$sql.= " WHERE id =".$_data['id'];
						$response['sql'] = $sql;
					}
					else
					{
						$keys = implode(",",array_keys($_data));
						$values = "'".implode("','", array_values($_data))."'";
		
						$response['keys'] = $keys;
						$response['values'] = $values;
		
						$sql = "INSERT INTO $name_table(".$keys.") VALUES ($values)";
						$response['sql'] = $sql;
					}

					if ($conn->query($sql) === TRUE) 
					{
						$response['message'] = "Data updated";
						$response['data']['id'] = $update?(int)$_data['id']: $conn -> insert_id;
					} 
					else 
					{
						$response['error']= "insert Error: $conn->error SQL $sql";
					}
				
					$conn->close();
				}
			}
			return $response;

		}

		function delete($data)
		{
			$conn_request = $this->getConn($this->name_db);
			$response = [];

			if(!isset($conn_request['error']))
			{
				$table = $data['table'];
				$_data = $data['data'];
				$id = $_data['id'];
				$where = $_data['where']?$_data['where']:"WHERE id=$id;";
				$where = $this->fixWhere($where);
				$response['sql'] = "DELETE FROM $table $where";
				$conn = $conn_request["conn"];
		
				if ($conn->query($response['sql']) === TRUE) 
				{
					$response['message'] = "$table : $id deleted successfully";
				} 
				else 
				{
					$response['error']= "creating table: $conn->error SQL $sql";
				}
				$conn->close();
			}
			else  $response['error'] = $conn_request['error'];
			return $response;
		}

		function getRows($data)
		{
			$response = [];

			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				$search = $this->getSearchString($data);
				
				$response['fields'] = $fields;
				$join = getVal($data,'join');
				$where = getVal($data,'where');

				$where .= " ".$search;

				$where = $this->fixWhere($where);

				$table = $data['table'];

				$response['sql'] = "SELECT $fields FROM `$table` $join $where";
				try 
				{
					if( !isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}
				return $response;
			}
		}

		function getSearchString($data)
		{
			$result = "";
			try 
			{
				$search = getVal($data,'search');
				$fields = getVal($data,'search_fields');
				if(isset($search) && !empty($search))
				{
					if(isset($fields) && isset($search))
					foreach ($fields as $field) 
					{
						if(is_null($result)) $result ="WHERE ". $field." LIKE '%".$search."%'";
						else $result .= "OR ".$field. " LIKE %".$search."%";
					}
				}
				return   $result;
			} catch (\Throwable $th) 
			{
				return   $result;
			}
		}

		function getfields($data)
		{
			$result = null;
			
			$fields = getVal($data,'fields');
			if(isset($fields) && is_array($fields))
			{
				foreach ($fields as $field) 
				{
					if(is_null($result)) $result = $field;
					else $result .= ", ".$field;
				}
			}
			else $result = "*";
			return $result;
		}

		function replaceAtIndex($from, $to, $content)
		{
			$newstring = $content;
			if($content)
			{
				$pos = strpos($content, $from);
				if ($pos !== false) 
				{
					$newstring = substr_replace($content, $to, $pos, strlen($from));
				}
			}
			return $newstring;
		}

		function fixWhere($where)
		{
			if(!$where) return "";
			$where = str_replace("WHERE","AND",$where);
			$where = $this->replaceAtIndex("AND","WHERE",$where);
			return $where;
		}

	// BASIC CALLS //

	// AUTH CALLS //
		function getAuthFromAuthHash($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];

				$auth_hash = $data['data']['auth_hash'];
				$response['sql'] = "SELECT $fields FROM `$table` where auth_hash = '$auth_hash'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}
				return $response;
			}
		}

		function deleteAuth($data)
		{
			$conn_request = $this->getConn($this->name_db);
			$response = [];

			if(!isset($conn_request['error']))
			{
				$table = $data['table'];
				$_data = $data['data'];
				$auth_hash = $_data['auth_hash'];
				$auth_deleted = $_data['auth_deleted'];
				$field = 'auth_deleted';
				$where = $_data['where']?$_data['where']:"WHERE auth_hash = '$auth_hash';";
				$where = $this->fixWhere($where);
				$response['sql'] = "UPDATE `$table` SET `$field` = '$auth_deleted' $where";
				print_r($response['sql']);
				$conn = $conn_request["conn"];
		
				if ($conn->query($response['sql']) === TRUE) 
				{
					$response['message'] = "$table : $field auth deleted successfully";
				} 
				else 
				{
					$response['error']= "creating table: $conn->error SQL $sql";
				}
				$conn->close();
			}
			else  $response['error'] = $conn_request['error'];
			return $response;

		}
	// AUTH CALLS //

	// CLIENT CALLS //
		function getClientIdFromUserId($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];
				$userId = $data['data']['id'];
				$response['sql'] = "SELECT $fields FROM `$table` where user_id = '$userId'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}

				return $response;
			}
		}

		function getClientIdFromOrderId($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];
				$orderId = $data['data']['id'];
				$response['sql'] = "SELECT $fields FROM `$table` where order_id = '$orderId'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}

				return $response;
			}
		}

		function getClientFromClientId($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];

				$client_id = $data['data']['client_id'];
				$response['sql'] = "SELECT $fields FROM `$table` where id = '$client_id'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}
				return $response;
			}
		}

		function getClientFromClientEmail($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];

				$client_email = $data['data']['email_address'];
				$response['sql'] = "SELECT $fields FROM `$table` where email_address = '$client_email'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}
				return $response;
			}
		}

		function editClientAddress($data)
		{
			$conn_request = $this->getConn($this->name_db);
			$response = [];

			if(!isset($conn_request['error']))
			{
				$table = $data['table'];
				$_data = $data['data'];
				$id = $_data['id'];
				$address = $_data['address'];
				$field = 'address';
				$where = $_data['where']?$_data['where']:"WHERE id = '$id';";
				$where = $this->fixWhere($where);
				$response['sql'] = "UPDATE `$table` SET `$field` = '$address' $where";
				$conn = $conn_request["conn"];
		
				if ($conn->query($response['sql']) === TRUE) 
				{
					$response['message'] = "$table : $field edited successfully";
				} 
				else 
				{
					$response['error']= "creating table: $conn->error SQL $sql";
				}
				$conn->close();
			}
			else  $response['error'] = $conn_request['error'];
			return $response;

		}
	// CLIENT CALLS //

	// ORDER CALLS //
		function getOrderFromOrderNumber($data)
		{
			// print_r("HERE");
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];
				$order_number = $data['data']['order_number'];
				$response['sql'] = "SELECT $fields FROM `$table` where order_number = '$order_number'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}

				return $response;
			}
		}

		function editOrder($data)
		{
			$conn_request = $this->getConn($this->name_db);
			$response = [];
			
			if(!isset($conn_request['error']))
			{
				$table = $data['table'];
				$_data = $data['data'];
				$order_number = $_data['order_number'];
				$order_cancelled = $_data['order_cancelled'];
				$field = 'order_cancelled';
				$where = $_data['where']?$_data['where']:"WHERE order_number = '$order_number';";
				$where = $this->fixWhere($where);
				$response['sql'] = "UPDATE `$table` SET `$field` = '$order_cancelled' $where";
				$conn = $conn_request["conn"];
		
				if ($conn->query($response['sql']) === TRUE) 
				{
					$response['message'] = "$table : $field edited successfully";
				} 
				else 
				{
					$response['error']= "creating table: $conn->error SQL $sql";
				}
				$conn->close();
			}
			else  $response['error'] = $conn_request['error'];
			return $response;

		}
	// ORDER CALLS //

	// USER LOGIN CALLS // 
		function getUser($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];

				$userName = $data['data']['user_name'];
				$userPass = $data['data']['user_pass'];
				$response['sql'] = "SELECT $fields FROM `$table` where user_name = '$userName' and user_pass = '$userPass'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}
				// print_r($response);
				return $response;
			}
		}
		
		function getUserFromUserId($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];
				$userId = $data['data']['user_id'];
				$response['sql'] = "SELECT $fields FROM `$table` where id = '$userId'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}

				return $response;
			}
		} 

		function getUserIdFromClientId($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];
				$userId = $data['data']['id'];
				$response['sql'] = "SELECT $fields FROM `$table` where client_id = '$userId'";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}

				return $response;
			}
		}

		function getOrders($data)
		{
			$response = [];
			
			$response['data__'] = $data;
			if($data)
			{
				$conn_request = $this->getConn($this->name_db);
				$conn = $conn_request["conn"];
		
				$fields = $this->getfields($data);
				
				$response['fields'] = $fields;
				
				$table = $data['table'];
			
				$response['sql'] = "SELECT * FROM `$table`";
				try 
				{
					if(!isset($conn_request['error']))
					{
						$result = $conn->query($response['sql']);
						
						$response['data_rows'] = $result->num_rows;
						$rows = [];
						if ($result->num_rows > 0) 
						{
							$response['data'] = mysqli_fetch_all ($result, MYSQLI_ASSOC);
						} 
						$result->free();
						$conn->close();
					}
					else  $response['error'] = $conn_request['error'];
				} 
				catch (\Throwable $th) 
				{
					$response['error'] = "merp";
				}

				return $response;
			}
		}
	// USER LOGIN CALLS // 
}